From 22fd419aeaae458cf92bd2918265e72574984bea Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jul 25 2017 14:48:11 +0000
Subject: [PATCH 904/1001] Tranfer the hub edit mode to the widgets


Some widgets display no chrome when there is no data. However, in edit
mode, the chrome should be displayed anyway or the widget can't be
configured, removed, or moved on the page.

This change allows widgets to be informed of the display mode and
display the panel chrome accordingly.

---

diff --git a/hubs/tests/test_widget_view.py b/hubs/tests/test_widget_view.py
new file mode 100644
index 0000000..328d207
--- /dev/null
+++ b/hubs/tests/test_widget_view.py
@@ -0,0 +1,34 @@
+from __future__ import unicode_literals
+
+import six
+from mock import Mock
+
+from hubs.app import app
+from hubs.tests import APPTest
+from hubs.widgets.base import Widget
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.view import WidgetView, RootWidgetView
+
+
+class TestingWidget(Widget):
+    name = "testing"
+
+
+class WidgetViewTest(APPTest):
+
+    def test_root_view(self):
+        testing_widget = TestingWidget()
+        view = RootWidgetView(testing_widget)
+        self.assertEqual(view.name, "root")
+        self.assertEqual(view.url_rules, ["/"])
+        self.assertEqual(view.template_name, "root.html")
+
+    def test_root_view_edit_mode(self):
+        testing_widget = TestingWidget()
+        view = RootWidgetView(testing_widget)
+        with app.test_request_context('/'):
+            context = view.get_extra_context(None)
+        self.assertFalse(context["edit_mode"])
+        with app.test_request_context('/?editmode=1'):
+            context = view.get_extra_context(None)
+        self.assertTrue(context["edit_mode"])
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index 1de5e0c..196ace3 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 
 
 class About(Widget):
@@ -17,11 +18,7 @@ class About(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "about.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 00eae24..ee1ff98 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -4,7 +4,8 @@ import operator
 import requests
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -21,11 +22,7 @@ class Badges(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "badges.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         context = {"title": self.widget.label}
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index b55f1e8..a57d72b 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -6,16 +6,14 @@ import pkgwat.api
 
 from hubs.utils.pkgdb import get_owned_packages
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
 log = logging.getLogger('hubs.widgets')
 
 
-PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
-
-
 class Bugzilla(Widget):
 
     name = "bugzilla"
@@ -36,11 +34,7 @@ class Bugzilla(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "bugzilla.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/contact/__init__.py b/hubs/widgets/contact/__init__.py
index 59b7a1d..0d6c6b3 100644
--- a/hubs/widgets/contact/__init__.py
+++ b/hubs/widgets/contact/__init__.py
@@ -5,7 +5,8 @@ import hubs.models
 import requests
 import six
 
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 from hubs.utils.views import login_required
 
 
@@ -15,11 +16,7 @@ class Contact(Widget):
     position = "both"
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "contact.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         ''' Data for Contact widget. Checks if the hub associated
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index 463e359..d6733b7 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 class Dummy(Widget):
@@ -17,11 +18,7 @@ class Dummy(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "dummy.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index fe86e40..2cecb75 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -8,7 +8,8 @@ import requests
 from hubs.utils import get_fedmsg_config
 from hubs.utils.text import commas
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -29,11 +30,7 @@ class FedmsgStats(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "fedmsgstats.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index 9010ad1..9a58891 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -4,7 +4,8 @@ from __future__ import unicode_literals, absolute_import
 import logging
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 
 from .functions import GetData
 
@@ -28,11 +29,7 @@ class Feed(Widget):
     cached_functions_module = ".functions"
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "feed.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 38e69e6..b17eb7a 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -3,7 +3,8 @@ from __future__ import unicode_literals
 from six.moves.xmlrpc_client import ServerProxy
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -28,11 +29,7 @@ class FedoraHosted(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "fhosted.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_tickets = GetTickets(instance)
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 2de11a3..f52c149 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -5,7 +5,8 @@ import logging
 from hubs.utils import get_fedmsg_config
 from hubs.utils.github import github_repos, github_pulls
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -34,11 +35,7 @@ class GitHubPRs(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "github_pr.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index 4da6f9f..e2a25e2 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -3,7 +3,8 @@ from __future__ import unicode_literals
 import requests
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -34,11 +35,7 @@ class GitHubIssues(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "githubissues.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index ada528b..584fb53 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -9,7 +9,7 @@ from flask.signals import template_rendered
 from hubs.models import Hub
 from hubs.utils.views import get_hub, require_hub_access
 from hubs.widgets import registry
-from hubs.widgets.base import WidgetView
+from hubs.widgets.view import WidgetView, RootWidgetView
 from .functions import GetRequests
 from .utils import find_hubs_for_msg, paginate
 
@@ -19,13 +19,9 @@ except ImportError:
     before_render_template = None  # Flask < 0.11
 
 
-class BaseView(WidgetView):
+class BaseView(RootWidgetView):
     """The base view to instantiate the widget."""
 
-    name = "root"
-    url_rules = ["/"]
-    template_name = "halp.html"
-
     def get_context(self, instance, *args, **kwargs):
         return dict(
             hubs=instance.config.get("hubs", []),
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index 803b56a..3eddd2d 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import clean_input, validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 class Library(Widget):
@@ -19,11 +20,7 @@ class Library(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "library.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         urls = [
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index 49388a2..c1fcf37 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 class Linechart(Widget):
@@ -18,11 +19,7 @@ class Linechart(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "linechart.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index e8eec08..0633d40 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -7,7 +7,8 @@ import requests
 
 from hubs.utils.text import markup
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -37,11 +38,7 @@ class Meetings(Widget):
         return env
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "meetings.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_meetings = GetMeetings(instance)
diff --git a/hubs/widgets/memberships/__init__.py b/hubs/widgets/memberships/__init__.py
index 20f14c0..ff57c74 100644
--- a/hubs/widgets/memberships/__init__.py
+++ b/hubs/widgets/memberships/__init__.py
@@ -2,7 +2,8 @@ from __future__ import unicode_literals
 
 import hubs.models
 
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 ELLIPSIS_LIMIT = 3
@@ -15,11 +16,7 @@ class Memberships(Widget):
     position = "both"
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "memberships.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         hub = instance.hub
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 3f51323..9346e54 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 import requests
@@ -24,11 +25,7 @@ class PagurePRs(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "pagure_pr.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 85f7110..d8db995 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -3,7 +3,8 @@ from __future__ import unicode_literals
 import requests
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 pagure_url = "https://pagure.io/api/0"
@@ -24,11 +25,7 @@ class PagureIssues(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "pagureissues.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 1ec9c09..7331acd 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -4,7 +4,8 @@ from collections import OrderedDict as ordereddict
 
 from hubs.utils import username2avatar
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 ELLIPSIS_LIMIT = 5
@@ -42,11 +43,7 @@ class Rules(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "rules.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         owners = instance.hub.owners
diff --git a/hubs/widgets/stats/__init__.py b/hubs/widgets/stats/__init__.py
index b139175..b893feb 100644
--- a/hubs/widgets/stats/__init__.py
+++ b/hubs/widgets/stats/__init__.py
@@ -3,7 +3,8 @@ from __future__ import unicode_literals
 import flask
 
 from hubs.utils.text import commas
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -13,11 +14,7 @@ class Stats(Widget):
     position = "right"
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "stats.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_stats = GetStats(instance)
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index ee22bc6..f452d24 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -1,7 +1,8 @@
 from __future__ import unicode_literals
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 
 
 class Sticky(Widget):
@@ -19,11 +20,7 @@ class Sticky(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "sticky.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         # TODO -- render with markdown
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 05d0693..c3b9cb8 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -7,7 +7,8 @@ from fedmsg.meta.base import BaseConglomerator as BC
 import hubs.models
 from hubs.utils import get_fedmsg_config
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -28,11 +29,7 @@ class Subscriptions(Widget):
         )]
 
 
-class BaseView(WidgetView):
-
-    name = "root"
-    url_rules = ["/"]
-    template_name = "subscriptions.html"
+class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         context = dict(title="Hubs")
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 2f956bf..c5aec95 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -135,3 +135,18 @@ class WidgetView(View):
                 flask._app_ctx_stack.top.app,
                 template=template, context=context)
             return output
+
+
+class RootWidgetView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "root.html"
+
+    def get_extra_context(self, *args, **kwargs):
+        """
+        Export the edit mode status to the template
+        """
+        context = super(RootWidgetView, self).get_extra_context(*args, **kwargs)
+        context["edit_mode"] = flask.request.args.get("editmode", "", type=bool)
+        return context
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 9ceb94b..8db3aeb 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -4,7 +4,8 @@ import requests
 
 from hubs.utils import username2avatar
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -23,10 +24,8 @@ class PendingACLs(Widget):
         )]
 
 
-class BaseView(WidgetView):
+class BaseView(RootWidgetView):
 
-    name = "root"
-    url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
     template_name = "pendingacls.html"
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 6f36260..413631b 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -3,7 +3,8 @@ from __future__ import unicode_literals
 import requests
 
 from hubs.widgets import validators
-from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.base import Widget
+from hubs.widgets.view import WidgetView, RootWidgetView
 from hubs.widgets.caching import CachedFunction
 
 
@@ -27,10 +28,8 @@ class Updates2Stable(Widget):
         )]
 
 
-class BaseView(WidgetView):
+class BaseView(RootWidgetView):
 
-    name = "root"
-    url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
     template_name = "updates2stable.html"
 

